// Hydlide 3 (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*18*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,dn;
	unsigned char id1[] = "HYD3 A-DISK";
	unsigned char id2[] = "HYD3 B-DISK Code";
	unsigned char id3[] = "HYD3 UserDisk";

	// OPMpf[^ (Disk A)
	struct fpos ma1[] =
	{
		{ 0x45, 0x07, 0x0000, 0x0800 },	// 
		{ 0x45, 0x0f, 0x0000, 0x0b00 },	// 
		{ 0x46, 0x08, 0x0000, 0x0500 },	// 
		{ 0x46, 0x0d, 0x0000, 0x0500 },	// 
		{ 0x46, 0x12, 0x0000, 0x0700 },	// 
		{ 0x47, 0x07, 0x0000, 0x0700 },	// 
		{ 0x47, 0x0e, 0x0000, 0x0500 },	// 
		{ 0x48, 0x01, 0x0000, 0x0200 },	// 
		{ 0x48, 0x03, 0x0000, 0x0500 },	// 
		{ 0x48, 0x0f, 0x0000, 0x0600 },	// 
		{ 0x49, 0x03, 0x0000, 0x0800 },	// 
		{ 0x49, 0x0b, 0x0000, 0x0800 },	// 
		{ 0x4a, 0x01, 0x0000, 0x0200 },	// 
		{ 0x0b, 0x09, 0x0000, 0x0500 },	// 
		{ 0x0b, 0x0e, 0x0000, 0x0400 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	// PSGpf[^ (Disk A)
	struct fpos mb1[] =
	{
		{ 0x42, 0x0b, 0x0000, 0x0400 },	// 
		{ 0x42, 0x0f, 0x0000, 0x0600 },	// 
		{ 0x43, 0x03, 0x0000, 0x0300 },	// 
		{ 0x43, 0x06, 0x0000, 0x0300 },	// 
		{ 0x43, 0x09, 0x0000, 0x0500 },	// 
		{ 0x43, 0x0e, 0x0000, 0x0400 },	// 
		{ 0x43, 0x12, 0x0000, 0x0300 },	// 
		{ 0x44, 0x03, 0x0000, 0x0100 },	// 
		{ 0x44, 0x04, 0x0000, 0x0300 },	// 
		{ 0x44, 0x07, 0x0000, 0x0400 },	// 
		{ 0x44, 0x0b, 0x0000, 0x0200 },	// 
		{ 0x44, 0x0d, 0x0000, 0x0400 },	// 
		{ 0x44, 0x11, 0x0000, 0x0300 },	// 
		{ 0x45, 0x02, 0x0000, 0x0400 },	// 
		{ 0x45, 0x06, 0x0000, 0x0100 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc==3)
	{
		dn = atoi(argv[2]);
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x12);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);

		if (((!memcmp(&buff[0xf0], id1, sizeof(id1))) && dn!=2) || dn==1)
		{
			printf("Disk A F܂.\n");
			fcut("BIOS",   0x00, 0x00, 0x00, 0x05, 0x01, 0x0000, 0x0500);
			fcut("OPMDRV", 0x4e, 0x27, 0x00, 0x08, 0x01, 0x0000, 0x0a00);
			fcut("PSGDRV", 0x41, 0x20, 0x01, 0x08, 0x01, 0x0000, 0x0900);

			// OPMpf[^̐؂o
			for (i=0; ma1[i].trk; i++)
			{
				sprintf(fname,"MA0%02d",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x01, ma1[i].ofs, ma1[i].size);
			}
			// PSGpf[^̐؂o
			for (i=0; mb1[i].trk; i++)
			{
				sprintf(fname,"MB0%02d",i);
				fcut(fname, mb1[i].trk, mb1[i].trk>>1, mb1[i].trk&1, mb1[i].sec, 0x01, mb1[i].ofs, mb1[i].size);
			}
		}
	}
	return 0;
}

